SetupFullscreen(1280, 720, "The Story of Kjellfrid the Horse");

horse_layer = new Layer();
intro_layer = new Layer();
intro2_layer = new Layer();
landscape_layer = new Layer();
landscape2_layer = new Layer();
landscape3_layer = new Layer();
landscape4front_layer = new Layer();
landscape4_layer = new Layer();
landscape5_layer = new Layer();
blade_layer = new Layer();
clock_layer = new Layer();
head_layer = new Layer();
text_layer = new Layer();
end_layer = new Layer();
madeby_layer = new Layer();

music = new AudioStream("data/music.ogg");

//HORSE LAYER
horse_layer.SetBlendMode(BlendModeReplace);
horses = []
for (i=0; i < 3; i++)
{
	horses[i] = new Quad(horse_layer, 0, 0, 1280, 720); 
	horses[i].SetImage("data/horse"+i+".png");
	horses[i].SetSize(0,0);
	horses[i].SetPosition(400,250);
}

//INTRO LAYERS
intro_layer.SetBlendMode(BlendModeReplace);
intro1 = new Quad(intro_layer, 0, 0, 1280, 720); 
intro1.SetImage("data/intro1.png");
intro2_layer.SetBlendMode(BlendModeReplace);
intro2 = new Quad(intro2_layer, 0, 0, 1280, 720);
intro2.SetImage("data/intro2.png");

//LANDSCAPE 1
landscape_layer.SetBlendMode(BlendModeReplace);
landscape1 = new Quad(landscape_layer, 0, 0, 3840, 720);
landscape1.SetImage("data/landscape1.png");

//LANDSCAPE 2
landscape2_layer.SetBlendMode(BlendModeReplace);
landscape2 = new Quad(landscape2_layer, 0, 0, 3840, 720);
landscape2.SetImage("data/landscape6.png");

//LANDSCAPE 3
landscape3_layer.SetBlendMode(BlendModeReplace);
landscape3 = new Quad(landscape3_layer, 0, 0, 3840, 720);
landscape3.SetImage("data/landscape3.png");

//LANDSCAPE 4 FRONT
landscape4front_layer.SetBlendMode(BlendModeReplace);
landscape4front = new Quad(landscape4front_layer, 0, 0, 1280, 720);
landscape4front.SetImage("data/front.png");

//LANDSCAPE 4
landscape4_layer.SetBlendMode(BlendModeReplace);
landscape4 = new Quad(landscape4_layer, 0, 0, 3840, 720);
landscape4.SetImage("data/landscape4.png");

//LANDSCAPE 5
landscape5_layer.SetBlendMode(BlendModeReplace);
landscape5 = new Quad(landscape5_layer, 0, 0, 1280, 720);
landscape5.SetImage("data/drap.png");

//BLADE
blade_layer.SetBlendMode(BlendModeReplace);
blade = new Quad(blade_layer, -90, -350, 1280, 720);
blade.SetImage("data/blad.png");

//HEAD
head_layer.SetBlendMode(BlendModeReplace);
head = new Quad(head_layer, 0, 0, 1280, 720);
head.SetImage("data/hode.png");

//END
end_layer.SetBlendMode(BlendModeReplace);
end = new Quad(end_layer, 0, 0, 1280, 720);
end.SetImage("data/end.png");

//MADEBY
madeby_layer.SetBlendMode(BlendModeReplace);
madeby = new Quad(madeby_layer, 0, 0, 1280, 720);
madeby.SetImage("data/madeby.png");

//TEXT
font = new Font("data/fonts/comic.ttf", 20);
text = new Text(text_layer, font, "0.0", 0, 0, 180, 100);
text.SetColor(1, 1, 1, 1);

//FLOWERS
world = new World();
flower = new WorldObject(world, "data/models/blomst.dae");
flower.SetProgram("data/shaders/envmapping.cg");
flower.SetParameters({"DiffuseMap":"data/textures/env.jpg"});
flower2 = new WorldObject(world, "data/models/blomst.dae");
flower2.SetProgram("data/shaders/envmapping.cg");
flower2.SetParameters({"DiffuseMap":"data/textures/env2.jpg"});
flower2.SetScale(0,0,0);
flower3 = new WorldObject(world, "data/models/blomst.dae");
flower3.SetProgram("data/shaders/envmapping.cg");
flower3.SetParameters({"DiffuseMap":"data/textures/env3.jpg"});
flower3.SetScale(0,0,0);

fb = new Framebuffer(1280, 720, 0, PixelFormatR8G8B8A8, true, true);

world.SetCameraPosition(30, 40, 30);
world.SetCameraTarget(0,0,0);

function drawHorse()
{
	p = Math.round(time*7)%3;
	horses[p].SetSize(750,422);
	horses[p].SetPosition(400,Math.cos(20+time*20)*2+250);
	horse_layer.Render();
	horses[p].SetSize(0,0);
}

function drawFlyingHorse()
{			
	horses[0].SetSize(750,422);
	horses[0].SetPosition(Math.sin(time*7)*35+400, Math.cos(time*7)*35+150);
	horse_layer.Render();
	horses[0].SetSize(0,0);
}

music.Play();

while (Update() && !KeyDown(KeyEsc))//-------------------------------------------------------------------------------------------
{
	Clear(0,0,0,1);
	time = GetTime()+0;
	
	if (time < 14.0)
	{
		flower.SetRotation(time*80, time*30, time*60, 1);
		flower.SetScale(0.3,0.3,0.3);
		PushFramebuffer(fb);
		Clear(0,0,0,1);
		world.Render();
		PopFramebuffer();
		
		fb.Blit();
		
		if (time < 9.0) intro_layer.Render();
		else if (time > 9.0) intro2_layer.Render();
	}
	else if (time < 145.0)
	{
		flower.SetRotation(time*80, time*30, time*60, 1);
		flower.SetScale(Math.sin(time*2)*0.3,Math.cos(time*3)*0.3,0.3);
		flower.SetPosition(Math.sin(time)*20, Math.cos(time+2)*30, 0);
		
		flower2.SetRotation(time*20+2, time*50+12, time*10+1, 1);
		flower2.SetScale(Math.sin(time*2)*0.3,Math.cos(time*3)*0.3,0.3);
		flower2.SetPosition(Math.cos(time)*20, Math.cos(time+2)*30, 0);
		
		flower3.SetRotation(time*40+12, time*20+2, time*30+1, 1);
		flower3.SetScale(Math.cos(time*5)*0.3,Math.sin(time*2)*0.3,0.3);
		flower3.SetPosition(Math.cos(time*3)*10, Math.sin(time+2)*20, 0);
		
		PushFramebuffer(fb);
		Clear(0,0,0,1);
		world.Render();
		PopFramebuffer();
			
		fb.Blit();
		
		p = Math.round(time*7)%3;
		
		if (time > 22.0 && time < 51.0)
		{
			landscape1.SetPosition(-3840+(time-30.0)*250);
			landscape_layer.Render();
		}		
		else if (time > 51.0 && time < 75.0)
		{
			landscape2.SetPosition(-3840+(time-51.0)*250);
			landscape2_layer.Render();
		}		
		else if (time > 75.0 && time < 98.0)
		{
			landscape3.SetPosition(-3840+(time-75.0)*250);
			landscape3_layer.Render();
		}
		else if (time > 98.0 && time < 125.0)
		{
			landscape4.SetPosition(-3840+(time-110.0)*250);
			landscape4_layer.Render();
		}
		else if (time > 125.0 && time < 130.0)
		{
			landscape4.SetPosition(0,0);
			landscape4_layer.Render();
		}		
		
		if (time < 32.0) drawFlyingHorse();
		else if (time > 32.0 && time < 48.0) drawHorse();
		else if (time > 48.0 && time < 53.0) drawFlyingHorse();
		else if (time > 53.0 && time < 68.0) drawHorse();
		else if (time > 68.0 && time < 78.0) drawFlyingHorse();
		else if (time > 78.0 && time < 93.0) drawHorse();
		else if (time > 93.0 && time < 112.0) drawFlyingHorse();
		else if (time > 112.0 && time < 115.0) drawHorse();
		else if (time > 115.0 && time < 118.0) landscape4front_layer.Render();
		else if (time > 118.0 && time < 124.0) drawHorse();
		else if (time > 124.0 && time < 131.0)
		{
			landscape5_layer.Render();
			blade.SetPosition(-90, -350+(time-130.0)*350);
			blade_layer.Render();
			head_layer.Render();
		}
		else if (time > 131.0 && time < 136.0)
		{
			end_layer.Render();
		}
		else if (time > 136.0 && time < 145.0)
		{
			madeby_layer.Render();
		}
		text.SetText(time);
		text_layer.Render();
	 }
	 else break;
}